<template>
  <div class="container extended pt-5 pb-5">
    <div>
      <b-form-group label="Language">
        <b-form-select
          v-model="selectedLanguage"
          :options="languages"
          @change="onLanguage"
        ></b-form-select>
      </b-form-group>
    </div>

    <div>
      15 random entries will be shown on the index page each visit.
    </div>

    <div class="bg-dark p-2 mt-4">
      <h3>new entry</h3>
      <b-form @submit.prevent="onSave">
        <div class="row">
          <div class="col-6">
            <b-form-group label="Title">
              <b-form-input v-model="form.title"></b-form-input>
            </b-form-group>
          </div>
          <div class="col-6">
            <b-form-group label="Link">
              <b-form-input v-model="form.url"></b-form-input>
            </b-form-group>
          </div>
        </div>
        <b-button :disabled="!formValid" variant="info" type="submit"
          >save</b-button
        >
      </b-form>
    </div>

    <div class="mt-4">
      <div
        v-for="entry in wikiLinks"
        :key="entry.id"
        class="row striped to-stripe"
      >
        <div class="col-5">{{ entry.title }}</div>
        <div class="col-6">
          <a :href="entry.url" target="_blank">{{ entry.url }}</a>
        </div>
        <div class="col-1 pt-1 pb-1">
          <b-button @click="onDelete(entry)" variant="danger">
            <font-awesome-icon :icon="['fas', 'trash']" />
          </b-button>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  layout: 'admin',
  roles: ['ROLE_EDITOR_WIKI', 'ROLE_SYSOP'],
  data() {
    return {
      languages: ['en', 'de', 'fr', 'es', 'ru'],
      selectedLanguage: 'en',
      form: {},
      wikiLinks: [],
    };
  },
  computed: {
    formValid() {
      return (
        this.form &&
        this.form.title &&
        this.form.title !== '' &&
        this.form.url &&
        this.form.url !== ''
      );
    },
  },
  mounted() {
    this.refreshData();
  },
  methods: {
    refreshData() {
      this._loadData();
    },
    async _loadData() {
      const loader = this.$loading.show();

      const result = await this.$axios.$get(
        `/admin/wiki/${this.selectedLanguage}`
      );

      this.wikiLinks = result;

      loader.hide();
    },
    onDelete(entry) {
      this.$bvModal
        .msgBoxConfirm('Are you sure?')
        .then((value) => {
          if (value === true) {
            this._deleteEntry(entry.id);
          }
        })
        // eslint-disable-next-line handle-callback-err
        .catch((err) => {
          // An error occurred
        });
    },
    async _deleteEntry(id) {
      const loader = this.$loading.show();

      await this.$axios.$delete(`/admin/wiki/${id}`);

      loader.hide();

      this.refreshData();
    },
    async onSave() {
      if (!this.formValid) {
        return;
      }

      const request = {
        lang: this.selectedLanguage,
        title: this.form.title,
        url: this.form.url,
      };

      this.form = {};

      const loader = this.$loading.show();

      await this.$axios.$post(`/admin/wiki`, request);

      loader.hide();

      this.refreshData();
    },
    onLanguage() {
      this.refreshData();
    },
  },
};
</script>
